package org.openjdk.gcbench.retain;

import org.openjdk.jmh.annotations.*;

import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.TimeUnit;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(Threads.MAX)
@State(Scope.Benchmark)
public class LinkedLists {

    Object retain;

    @Param({"100000"})
    private int size;

    @Setup
    public void setup() {
        Node n = new Node(null);
        for (int c = 0; c < size; c++) {
            n = new Node(n);
        }
        retain = n;
    }

    @Benchmark
    public Object test() {
        // allocation pressure to trigger GCs
        return new Object();
    }

    private static class Node {
        final Node next;
        final Object payload;
        public Node(Node next) {
            this.next = next;
            this.payload = new Object();
        }
    }

}
